use GD::Graph::smoothlines;
use GD::Graph::bars;
use GD::Graph::Data;
use GD::Graph::pie;
use Tk::PNG; 
use Tk::JPEG;
use List::Util qw(sum);

######################## average quality ################################
sub qualline
{
	$c0to5=0;
	$c6to10=0;
	$c11to15=0;
	$c16to20=0;
	$c21to25=0;
	$c26to30=0;
	$c31to35=0;
	$c36to40=0;
	$c41to45=0;
	$c46to50=0;
	for($i=0;$i<scalar(@file);$i=$i+4)
	{
		$count=0;
		$line=$file[$i+1];
		@seqQ2=();
		for($j=0;$j<length($line);$j++)
		{
			$seqQ=substr($file[$i+3],$j,1);
			$seqqval=ord($seqQ)-33;
			push(@seqQ2,$seqqval);
		}
		
		$average=(sum(@seqQ2)/scalar(@seqQ2));
		if($average>=0 && $average<=5)
		{
			$c0to5++;
		}
		elsif($average>=6 && $average<=10)
		{
			$c6to10++;
		}
		elsif($average>=11 && $average<=15)
		{
			$c11to15++;
		}
		elsif($average>=16 && $average<=20)
		{
			$c16to20++;
		}
		elsif($average>=21 && $average<=25)
		{
			$c21to25++;
		}
		elsif($average>=26 && $average<=30)
		{
			$c26to30++;
		}
		elsif($average>=31 && $average<=35)
		{
			$c31to35++;
		}
		elsif($average>=36 && $average<=40)
		{
			$c36to40++;
		}
		elsif($average>=41 && $average<=45)
		{
			$c41to45++;
		}
		elsif($average>=46 && $average<=50)
		{
			$c46to50++;
		}
	}
	$data = GD::Graph::Data->new([
    [ '0-5','6-10', '11-15','16-20','21-25', '26-30','31-35', '36-40','41-45', '46-50'],
    [$c0to5,$c6to10,$c11to15,$c16to20,$c21to25,$c26to30,$c31to35,$c36to40,$c41to45,$c46to50]
  ])or die GD::Graph::Data->error;
	
	$graph = GD::Graph::bars->new(500,500);

	$graph->set( 
	title      => 'Sequence quality distribution',
    x_label     => 'Quality                    ',
    y_label     => 'Sequences',
	line_width  => 4,
	transparent     => 0,
	markers => [6,6,6,6,6],	
	) or die $graph->error;
	$graph->set_title_font( "./Calibri.ttf", 16 );
	$graph->set_legend_font( "./Calibri.ttf", 10 );
	$graph->set_x_axis_font( "./Calibri.ttf", 9 );
	$graph->set_x_label_font( "./Calibri.ttf", 11 );
	$graph->set_y_axis_font( "./Calibri.ttf", 9 );
	$graph->set_y_label_font( "./Calibri.ttf", 11 );
	$graph->set(dclrs => [qw(#66A1F8)],	accent_treshold => 2);
	$graph->plot($data) or die $graph->error;

	$graph->set(line_types => [2],markers => [6,6,6,6,6],marker_size=>3);
	my $file = "$dir3/Average_quality.png";
	open(my $out, '>: raw', $file) or die "Cannot open '$file' for write: $!";
	binmode $out;
	print $out $graph->gd->png;
	close $out;
}

###################################length chart######################
sub lenchart
{

$maxlength=0;
@qual=();
@GCarray=();
$A=0;$T=0;$G=0;$C=0;$N=0;
for($i=0;$i<scalar(@file);$i=$i+4)
{
	$line=$file[$i+1];
	$qualityline=$file[$i+3];
	chomp($qualityline);
	push(@qual,$qualityline);
	@seqQ3=();
	for($j=0;$j<length($line);$j++)
	{
		$seqQ=substr($file[$i+3],$j,1);
		$seqqval=ord($seqQ)-33;
		push(@seqQ3,$seqqval);
	}
	$g=0;$c=0;
	for($j=0;$j<length($line);$j++)
	{
		$element=substr($file[$i+1],$j,1);
		if ($element =~/A/) # match nucleotide pattern and countstrong text
			{ $A++;	}
            elsif ($element =~/T/)
			{ $T++;}
             elsif ($element =~/G/)
			{$G++;$g++;}
             elsif ($element =~/C/)
			{$C++;$c++;}
			else
			{$N++;}
	}
	$GC=$g+$c;
	push(@GCarray,$GC);
	if(scalar(@seqQ3)>$maxlength)
	{
		$maxlength=scalar(@seqQ3);
	}
}
	

@lenarr=();
@lcount=();
@inter=();
sort @GCarray;
$interval=abs($maxlength/10);
for($i=0;$i<scalar(@file);$i=$i+4)
{
	$eachSeqQualLine=$file[$i+3];
	chomp($eachSeqQualLine);
	push(@lenarr,length($eachSeqQualLine));
}
for($i=0;$i<=$maxlength;$i=$i+$interval)
{
	$count=0;
	for($j=0;$j<scalar(@lenarr);$j++)
	{
		
		if($lenarr[$j]<=($i+$interval) && $lenarr[$j]>($i))
		{
			$count++;
		}
	}
	push(@lcount,($count/scalar(@lenarr))*100);
	$iiii=$i+$interval;
	$i1=ceil($i);
	$iiii1=ceil($iiii);
	$in="$i1".'-'."$iiii1";
	push(@inter,$in);
}
	$data1 = GD::Graph::Data->new([
    [@inter],
	[@lcount ]
  ])or die GD::Graph::Data->error;

	$graph = GD::Graph::bars->new(600,600);

	$graph->set( 
	title      => 'Sequence length distribution',
    x_label     => 'Length                              ',
    y_label     => 'Percentage of Sequence',
	bar_spacing => 20,
	bar_width => 20,
	transparent => 0,
	) or die $graph->error;
	$graph->set_title_font( "./Calibri.ttf", 16 );
	$graph->set_legend_font( "./Calibri.ttf", 10 );
	$graph->set_x_axis_font( "./Calibri.ttf", 9 );
	$graph->set_x_label_font( "./Calibri.ttf", 11 );
	$graph->set_y_axis_font( "./Calibri.ttf", 9 );
	$graph->set_y_label_font( "./Calibri.ttf", 11 );

	$graph->set(dclrs => [qw(#66A1F8)],	accent_treshold => 2);
	$graph->plot($data1) or die $graph->error;

	my $file = "$dir3/length.png";
	#print $file;
	open(my $out, '> :raw', $file) or die "Cannot open '$file' for write: $!";
	binmode $out;
	print $out $graph->gd->png;
	close $out;
 
 
 
 	$AA=sprintf("%.2f",$A/($A+$T+$G+$C+$N)*100);
	$TT=sprintf("%.2f",$T/($A+$T+$G+$C+$N)*100);
	$GG=sprintf("%.2f",$G/($A+$T+$G+$C+$N)*100);
	$CC=sprintf("%.2f",$C/($A+$T+$G+$C+$N)*100);
	$NN=sprintf("%.2f",$N/($A+$T+$G+$C+$N)*100);
	$data2 = [
            ["A-$AA%","T-$TT%","G-$GG%","C-$CC%","Non-ATGC-$NN%"],
            [$AA,$TT,$GG,$CC,$NN]
        ];
		$graph = GD::Graph::pie->new(500,500);
	$graph->set( 
	pie_height=>20,
	start_angle=>60,
	title      => 'Base Composition',
	) or die $graph->error;
	
	$graph->set_title_font( "./Calibri.ttf", 16 );
    $graph->set_value_font( "./Calibri.ttf", 12 );
	
	$graph->set( dclrs => [ qw(#66A1F8 #F8CC66 #F76B0B #58BE4A #765DDE) ] );
	$graph->plot($data2) or die $graph->error;
	
	my $file2 = "$dir3/atgc.png";
	#print $file;
	open(my $out, '> :raw', $file2) or die "Cannot open '$file' for write: $!";
	binmode $out;
	print $out $graph->gd->png;
	close $out;
 
 ##################################################GC percentage######################
 $GC10=0;
 $GC20=0;
 $GC30=0;
 $GC40=0;
 $GC50=0;
 $GC60=0;
 $GC70=0;
 $GC80=0;
 $GC90=0;
 $GC100=0;
 $GC1000=0;
 for($i=0;$i<scalar(@GCarray);$i++){
	if($GCarray[$i]<=10){
		$GC10++;
	}
	if($GCarray[$i]<=20 && $GCarray[$i]>10){
		$GC20++;
	}
	if($GCarray[$i]<=30 && $GCarray[$i]>20){
		$GC30++;
	}
	if($GCarray[$i]<=40 && $GCarray[$i]>30){
		$GC40++;
	}
	if($GCarray[$i]<=50 && $GCarray[$i]>40){
		$GC50++;
	}
	if($GCarray[$i]<=60 && $GCarray[$i]>50){
		$GC60++;
	}
	if($GCarray[$i]<=70 && $GCarray[$i]>60){
		$GC70++;
	}
	if($GCarray[$i]<=80 && $GCarray[$i]>70){
		$GC80++;
	}
	if($GCarray[$i]<=90 && $GCarray[$i]>80){
		$GC90++;
	}
	if($GCarray[$i]<=100 && $GCarray[$i]>90){
		$GC100++;
	}
 }
$data = GD::Graph::Data->new([
    ['0-10', '11-20', '21-30', '31-40', '41-50','51-60', '61-70', '71-80', '81-90', '91-100'],
	[$GC10*100/scalar(@GCarray),$GC20*100/scalar(@GCarray),$GC30*100/scalar(@GCarray),$GC40*100/scalar(@GCarray),$GC50*100/scalar(@GCarray),$GC60*100/scalar(@GCarray),$GC70*100/scalar(@GCarray)
	,$GC80*100/scalar(@GCarray),$GC90*100/scalar(@GCarray),$GC100*100/scalar(@GCarray)]
    
  ])or die GD::Graph::Data->error;

 	$graph = GD::Graph::bars->new(500,500);

	$graph->set( 
	title      => 'GCPercentage',
    x_label     => 'GC Percentage                                ',
    y_label     => 'percentage of sequences',
	bar_spacing => 20,
	bar_width => 20,
	transparent => 0,
	markers => [6,6,6,6,6],	
	) or die $graph->error;
	$graph->set_title_font( "./Calibri.ttf", 16 );
	$graph->set_legend_font( "./Calibri.ttf", 10 );
	$graph->set_x_axis_font( "./Calibri.ttf", 9 );
	$graph->set_x_label_font( "./Calibri.ttf", 11 );
	$graph->set_y_axis_font( "./Calibri.ttf", 9 );
	$graph->set_y_label_font( "./Calibri.ttf", 11 );
	$graph->set(dclrs => [qw(#66A1F8)],	accent_treshold => 2);
	$graph->plot($data) or die $graph->error;

	$graph->set(line_types => [3],markers => [6,6,6,6,6],marker_size=>3);
	my $file = "$dir3/GCPercentage.png";
	open(my $out, '>: raw', $file) or die "Cannot open '$file' for write: $!";
	binmode $out;
	print $out $graph->gd->png;
	close $out;


graphshow();
}


sub graphshow
{	
		$mw3 = MainWindow->new;
	$mw3->resizable(0,0);
	$mw3->geometry("700x300");
	$nb3 = $mw3->NoteBook->pack (-fill => 'both', -expand => 1);
	$calc4 = $nb3->add ('Results', -label => 'Results');
	$fm_look4 = $calc4->Frame(-relief=>'groove',-borderwidth=>5);
	$nb3->pageconfigure('Results',-state=>'normal');
	$nb3->raise('Results');
	$chartlabframe=$calc4->LabFrame(-label=>"Graphs",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'nw',-ipadx=>8,-ipady=>8);
	$linechart=$chartlabframe->Button(-text=>"Average based quality Graph",-font=>[-size =>'10'], -height => 1,-command=>\&qualitygraph)->pack(-side=>"left",-anchor=>'n');
	$linechart2=$chartlabframe->Button(-text=>"length based graph",-font=>[-size =>'10'], -height => 1,-command=>\&lengthgraph)->pack(-side=>"left",-anchor=>'n');
	$linechart3=$chartlabframe->Button(-text=>"ATGC Composition",-font=>[-size =>'10'], -height => 1,-command=>\&atgc)->pack(-side=>"left",-anchor=>'n');
	$linechart4=$chartlabframe->Button(-text=>"GC Percentage",-font=>[-size =>'10'], -height => 1,-command=>\&gcpercent)->pack(-side=>"left",-anchor=>'n');
}
return 1;
