use Tk;
use Tk::Checkbox;
use File::Basename;
use File::Path qw(make_path);
use Tk::Table;
use Tk::LabFrame;
use Tk::NoteBook;
use Tk::FileSelect;
use English;
use POSIX; 
use subs qw(create_puz xy);

################ Built methods ##########
use percentage_based;
use length_based;
use ambigious_based;
use homopolymer_based;
use graphs;
use fastqvalidate;
use pipeline;
use convert;
use adapt;

#############################################################
##################### main menu #############################
#############################################################

#calc1,calc2,calc3,calc4,calc5 are the tab frame under which all the lab frames are built
$p=0;
$mw = MainWindow->new;
$mw->resizable(0,0);
$mw->geometry("1250x700");

$nb = $mw->NoteBook->pack (-fill => 'both', -expand => 1);
################### Menu / Tabs ##################################
$calc1 = $nb->add ('About the tool', -label => 'About EasyQC');
$calc4 = $nb->add ('Format Convertor', -label => 'FASTQ converter');
$calc7 = $nb->add ('Flash', -label => 'Paired end merge');
$calc6 = $nb->add ('Trimmer', -label => 'Adapter trimmer');
$calc2 = $nb->add ('Easy QC', -label => 'QC Pipeline');
$calc5 = $nb->add ('Graphs', -label => 'Graphs');


##################### Welcome Tab - About EasyQC ##################
$wel_fm_dirs = $calc1->Frame(-relief=>'groove',-borderwidth=>1);
$wel_fm_dirs->pack(-side=>'top',-expand=>0,-fill=>'both');
$wel_frame1=$wel_fm_dirs->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-anchor=>'nw',-expand=>1,-fill=>'x');
$wel_label2=$wel_frame1->Label(-text=>"Welcome  ",-font=>[-size =>'20'])->pack(-anchor=>'center');
$welimage = $wel_frame1->Photo(-file => "logo.gif");
$wel_frame1->Button(-image => $welimage)->pack(-anchor=>"center");
$wel_label2=$wel_frame1->Label(-text=>" ",-font=>[-size =>'13'])->pack(-anchor=>"center");
$wel_label2=$wel_frame1->Label(-text=>"EasyQC provides an interactive interface for paired end merging, quality filtering, format conversion and generating graphical outputs of NGS data ",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"The FASTQ  converter is provided for easier and hassle-free down stream processing.",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"Paired end merge module enables the user to merge the paired end reads obtained from NGS platforms.",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"In quality control pipeline the order of execution is: ",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"1. Quality trimming                                                                2. Length trimming",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"3. Ambiguous base trimming                                              4. Homopolymer triomming",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"",-font=>[-size =>'12'])->pack(-anchor=>"nw");

$wel_label2=$wel_frame1->Label(-text=>"",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"Adapter trimmer enables the user to trim the adapter sequences from 5' and 3' ends.",-font=>[-size =>'11'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"The various graphical representation provided by EasyQC are as below:",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"1. Quality distrbution graph                                             2. Length distribution graph",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"3. Base Composition                                                      4. GC Content",-font=>[-size =>'12'])->pack(-anchor=>"nw");
$wel_label2=$wel_frame1->Label(-text=>"",-font=>[-size =>'12'])->pack(-anchor=>"nw");

################## Format converter ############
$cfm_dirs = $calc4->Frame(-relief=>'groove',-borderwidth=>1);
$cfm_dirs->pack(-side=>'top',-expand=>0,-fill=>'both');
$cframe1=$cfm_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');
$cframe2=$cfm_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');


###################################################
################### Convert Menu ##################
###################################################
$clabframe=$cframe1->LabFrame(-label=>"Load the FASTQ file",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'center',-ipadx=>10,-ipady=>10,-pady=>20,-padx=>20);
$clabel1=$clabframe->Label(-text=>"  ",-font=>[-size =>'10'])->pack(-side=>'left');
$clabel2=$clabframe->Label(-text=>"Choose your FASTQ file  ",-font=>[-size =>'10'])->pack(-side=>'left');
$centry=$clabframe->Entry(-width=>"50",-background=>"snow")->pack(-side=>"left");
$clabel1=$clabframe->Label(-text=>"                       ",-font=>[-size =>'10'])->pack(-side=>'left');
$cdown=$clabframe->Button(-text=>"Upload Fastq file",-font=>[-size =>'10'],-command=>\&upload1)->pack(-side=>"left");
$clabel1=$clabframe->Label(-text=>"     ",-font=>[-size =>'10'])->pack(-side=>'left');
$cdown=$cframe1->Button(-text=>"Submit",-font=>[-size =>'10'],-command=>\&submit1)->pack(-side=>"bottom");



 

################## Graphs ############
$gfm_dirs = $calc5->Frame(-relief=>'groove',-borderwidth=>1);
$gfm_dirs->pack(-side=>'top',-expand=>0,-fill=>'both');
$gframe1=$gfm_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');
$gframe2=$gfm_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');

#################################################
################### Graph Menu ##################
#################################################
$glabframe=$gframe1->LabFrame(-label=>"Load the FASTQ file",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'center',-ipadx=>10,-ipady=>10,-pady=>20,-padx=>20);
$glabel1=$glabframe->Label(-text=>"  ",-font=>[-size =>'10'])->pack(-side=>'left');
$glabel2=$glabframe->Label(-text=>"Choose your FASTQ file  ",-font=>[-size =>'10'])->pack(-side=>'left');
$gentry=$glabframe->Entry(-width=>"50",-background=>"snow")->pack(-side=>"left");
$glabel1=$glabframe->Label(-text=>"                       ",-font=>[-size =>'10'])->pack(-side=>'left');
$gdown=$glabframe->Button(-text=>"Upload Fastq file",-font=>[-size =>'10'],-command=>\&upload2)->pack(-side=>"left");
$glabel1=$glabframe->Label(-text=>"     ",-font=>[-size =>'10'])->pack(-side=>'left');
$gdown=$gframe1->Button(-text=>"Submit",-font=>[-size =>'10'],-command=>\&submit2)->pack(-side=>"bottom");



################ Title of tool #################
$mw->title("EasyQC");
$fm_dirs = $calc2->Frame(-relief=>'groove',-borderwidth=>1);
$fm_dirs->pack(-side=>'top',-expand=>0,-fill=>'both');
$frame1=$fm_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-anchor=>'nw',-expand=>1,-fill=>'x');

################## Trimmer ############
$tfm_dirs = $calc6->Frame(-relief=>'groove',-borderwidth=>1);
$tfm_dirs->pack(-side=>'top',-expand=>0,-fill=>'both');
$tframe1=$tfm_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');
$tframe2=$tfm_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');


###################################################
################### Trimmer Menu ##################
###################################################
$tlabframe=$tframe1->LabFrame(-label=>"Load the FASTQ file",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'center',-ipadx=>10,-ipady=>10,-pady=>20,-padx=>20);
$tlabel1=$tlabframe->Label(-text=>"  ",-font=>[-size =>'10'])->pack(-side=>'left');
$tlabel2=$tlabframe->Label(-text=>"Choose your FASTQ file  ",-font=>[-size =>'10'])->pack(-side=>'left');
$tentry=$tlabframe->Entry(-width=>"50",-background=>"snow")->pack(-side=>"left");
$tlabel1=$tlabframe->Label(-text=>"                       ",-font=>[-size =>'10'])->pack(-side=>'left');
$tdown=$tlabframe->Button(-text=>"Upload Fastq file",-font=>[-size =>'10'],-command=>\&tupload)->pack(-side=>"left");
$tlabel1=$tlabframe->Label(-text=>"     ",-font=>[-size =>'10'])->pack(-side=>'left');
$tdown=$tframe1->Button(-text=>"Submit",-font=>[-size =>'10'],-command=>\&tsubmit)->pack(-side=>"bottom");
#$tlabel2=$tframe2->Label(-text=>"Trimming the fastq with the bar code sequence",-font=>[-size =>'11'])->pack(-anchor=>"nw");


################## Flash ############
$pnseq_dirs = $calc7->Frame(-relief=>'groove',-borderwidth=>1);
$pnseq_dirs->pack(-side=>'top',-expand=>0,-fill=>'both');
$pframe1=$pnseq_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');
$pframe2=$pnseq_dirs->Frame(-relief=>'groove',-borderwidth=>5)->pack(-side=>'top',-anchor=>'nw',-expand=>1,-fill=>'x');


###################################################
################### Flash Menu ##################
###################################################
$plabframe=$pframe1->LabFrame(-label=>"Load the FASTQ file",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'center',-ipadx=>10,-ipady=>10,-pady=>20,-padx=>20);
$plabel1=$plabframe->Label(-text=>"  ",-font=>[-size =>'10'])->pack(-side=>'left');
$plabel2=$plabframe->Label(-text=>"Choose your forward FASTQ file  ",-font=>[-size =>'10'])->pack(-side=>'left');
$pentry=$plabframe->Entry(-width=>"50",-background=>"snow")->pack(-side=>"left");
$plabel1=$plabframe->Label(-text=>"                       ",-font=>[-size =>'10'])->pack(-side=>'left');
$pdown=$plabframe->Button(-text=>"Upload Fastq file",-font=>[-size =>'10'],-command=>\&pupload)->pack(-side=>"left");
######
$plabframe=$pframe1->LabFrame(-label=>"Load the FASTQ file",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'center',-ipadx=>10,-ipady=>10,-pady=>20,-padx=>20);
$plabe21=$plabframe->Label(-text=>"  ",-font=>[-size =>'10'])->pack(-side=>'left');
$plabe22=$plabframe->Label(-text=>"Choose your reverse FASTQ file  ",-font=>[-size =>'10'])->pack(-side=>'left');
$p1entry=$plabframe->Entry(-width=>"50",-background=>"snow")->pack(-side=>"left");
$plabel1=$plabframe->Label(-text=>"                       ",-font=>[-size =>'10'])->pack(-side=>'left');
$pdown=$plabframe->Button(-text=>"Upload Fastq file",-font=>[-size =>'10'],-command=>\&p1upload)->pack(-side=>"left");
######
$pdown=$pframe1->Button(-text=>"Submit",-font=>[-size =>'10'],-command=>\&flashsubmit)->pack(-side=>"bottom");

##############################################
################### QC Menu ##################
##############################################
$labframe=$frame1->LabFrame(-label=>"Load the FASTQ file",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'center',-ipadx=>10,-ipady=>10,-pady=>20,-padx=>20);
$label1=$labframe->Label(-text=>"  ",-font=>[-size =>'10'])->pack(-side=>'left');
$label2=$labframe->Label(-text=>"Choose your FASTQ file  ",-font=>[-size =>'10'])->pack(-side=>'left');
$entry=$labframe->Entry(-width=>"50",-background=>"snow")->pack(-side=>"left");
$label1=$labframe->Label(-text=>"                       ",-font=>[-size =>'10'])->pack(-side=>'left');
$down=$labframe->Button(-text=>"Upload Fastq file",-font=>[-size =>'10'],-command=>\&upload)->pack(-side=>"left");
$label1=$labframe->Label(-text=>"     ",-font=>[-size =>'10'])->pack(-side=>'left');
$cols = 2;
$rows = 8;
######################################################
#############Data Filtering options###################
######################################################
$labframe=$frame1->LabFrame(-label=>"Filtering options",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'nw',-side=>"left");

$table = $labframe->Table(
  -columns    => 4  ,	
  -rows       => 10,
  -relief     => 'groove',
);

$text='';
########### Quality cut-off menu display ############
$tmp1 = $table->Label(-width  => 30,
					 -height=>4,
                     -relief => 'groove');
$table->put(1,1,$tmp1);
$avgquality = $tmp1->Checkbutton(-text=>" Quality filter",
								-variable => \$qual,
								-command  => \&qualSub,
								-onvalue  => 'quality', 
								-offvalue => 'null',
								-state=>'active',
								-font=>[-size=>'10'])->pack(-side=>'left');
$avgquality-> deselect();
avgquality;


########### Length cut-off menu display ############
$tmp2 = $table->Label(-width  => 30,
					 -height=>4,
                     -relief => 'groove');
$table->put(2,1,$tmp2);
$lencutoff = $tmp2->Checkbutton(-text=>" Length filter",
								-variable => \$lencut,
								-command  => \&lenSub,
								-onvalue  => 'lencutoff', 
								-offvalue => 'null',
								-state=>'active',-font=>[-size=>'10'])->pack(-side=>'left');
$lencutoff-> deselect();
lencutoff;


########### Ambiguous cut-off menu display ############
$tmp3 = $table->Label(-width  => 30,
					 -height=>4,
                     -relief => 'groove');
$table->put(3,1,$tmp3);
$ambicutoff = $tmp3->Checkbutton(-text=>" Ambiguous base filter",
								-variable => \$ambicut,
								-command  => \&ambiSub,
								-onvalue  => 'ambicutoff', 
								-offvalue => 'null',
								-state=>'active',-font=>[-size=>'10'])->pack(-side=>'left');
$ambicutoff-> deselect();
ambicutoff;


########### Homopolymer cut-off menu display ############
$tmp4 = $table->Label(-width  => 30,
					 -height=>4,
                     -relief => 'groove');
$table->put(4,1,$tmp4);
$homocutoff = $tmp4->Checkbutton(-text=>" Homopolymer filter",
								-variable => \$homocut,
								-command  => \&homoSub,
								-onvalue  => 'homocutoff', 
								-offvalue => 'null',
								-state=>'active',-font=>[-size=>'10'])->pack(-side=>'left');
$homocutoff-> deselect();
homocutoff;


$down=$fm_dirs->Button(-text=>"Submit",-font=>[-size =>'10'],-command=>\&submit)->pack(-side=>"bottom");
$flag=0;
$flag1=0;
$flag2=0;
$flag3=0;
$flag4=0;
$flag5=0;


######################################################
#################  Trimmer options ###################
######################################################
$tlabframe=$tframe1->LabFrame(-label=>"Trimmer",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'nw',-side=>"left");

$ttable = $tlabframe->Table(
  -columns    => 4  ,	
  -rows       => 10,
  -relief     => 'groove',
);

$text='';
########### Left trimmer menu display ############
$tmp1 = $ttable->Label(-width  => 30,
					 -height=>4,
                     -relief => 'groove');
$ttable->put(1,1,$tmp1);
$ltrimmer = $tmp1->Checkbutton(-text=>" Left trimmer",
								-variable => \$ltrimcut,
								-command  => \&ltrim,
								-onvalue  => 'ltrim', 
								-offvalue => 'null',
								-state=>'active',
								-font=>[-size=>'10'])->pack(-side=>'left');
$ltrimmer-> deselect();
ltrim;


########### Right trimmer menu display ############
$tmp2 = $ttable->Label(-width  => 30,
					 -height=>4,
                     -relief => 'groove');
$ttable->put(2,1,$tmp2);
$rtrimmer = $tmp2->Checkbutton(-text=>" Right trimmer",
								-variable => \$rtrimcut,
								-command  => \&rtrim,
								-onvalue  => 'rtrim', 
								-offvalue => 'null',
								-state=>'active',-font=>[-size=>'10'])->pack(-side=>'left');
$rtrimmer-> deselect();
rtrim;


########################################
##############  subroutines ############
########################################

##################################################
########### quality cut-off subroutine ###########
##################################################
sub qualSub
{
	if($flag==0)
	{
		$frame2=$frame1->LabFrame(-label=>"Quality filter cut-off",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'sw');
		$qualtable = $frame2->Table(
						  -columns    => 4,
						  -rows       => 2,
						  -relief     => 'groove'
						)->pack(-side=>"left");

		$qualtmp11 = $qualtable->Label(-width  => 20,
					 -height=>1,
                     -relief => 'groove');
		$qualtable->put(1,1,$qualtmp11);
		$label2=$qualtmp11->Label(-text=>"Enter the quality cut-off",-font=>[-size =>'10'])->pack(-expand => '0',-fill => 'both',-side=>"left");
		
		$qualtmp12 = $qualtable->Label(-width  => 20,
					 -height=>2,
                     -relief => 'groove');
		$qualtable->put(1,2,$qualtmp12);
		$slide1=$qualtmp12->Scale( -orient=>'horizontal', -length=>150,-showvalue=>1,-to=>40, -tickinterval=>10 );
		
		$qualtmp21 = $qualtable->Label(-width  => 20,-height=>1,-relief => 'groove');
		$qualtable->put(1,3,$qualtmp21);
		$label4=$qualtmp21->Label(-text=>"Enter the precentage cut-off",-font=>[-size =>'10'])->pack(-side=>'left');
		
		$qualtmp22 = $qualtable->Label(-width  => 20,
					 -height=>1,
                     -relief => 'groove');
		$qualtable->put(1,4,$qualtmp22);
		$slide2=$qualtmp22->Scale( -orient=>'horizontal', -length=>150,-showvalue=>1, -tickinterval=>20 );
		
		
		$flag=1;
	}
	if($qual eq 'quality')
	{
		if($flag==1)
		{
		$frame2->pack(-anchor=>'sw');
		$slide1->pack(-side=>"left");
		$slide2->pack(-side=>"left");
		
		
		$flag=2;
		}
	}
	elsif ($qual eq "null")
	{
		if($flag==2)
		{
		$frame2->packForget();
		$slide1->packForget();
		$slide2->packForget();
		
		$flag=1;
		
		}
	
	}
}

#################################################################
################## length cut-off subroutine ####################
#################################################################

sub lenSub
{
	if($flag1==0)
	{
		$lenframe=$frame1->LabFrame(-label=>"Length cut-off",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'sw');
		$lentable = $lenframe->Table(
						  -columns    => 2,
						  -rows       => 2,
						  -relief     => 'groove'
						)->pack(-side=>"left");
						
		
		$lentmp11 = $lentable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$lentable->put(1,1,$lentmp11);
		$lenlabel=$lentmp11->Label(-text=>"Enter the length cut-off",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");
		
		$lentmp12 = $lentable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$lentable->put(1,2,$lentmp12);
		$lenentry=$lentmp12->Entry(-width=>"10",-background=>"snow",-textvariable=>\$lentxt)->pack(-side=>"left");
		
		$flag1=1;
	}
	if($lencut eq 'lencutoff')
	{
		if($flag1==1)
		{
		$lenframe->pack(-anchor=>'sw');
		$lenentry->pack(-side=>"left");

		
		$flag1=2;
		}
	}
	elsif ($lencut eq "null")
	{
	
		if($flag1==2)
		{
		$lenframe->packForget();
		$lenentry->packForget();
		$flag1=1;
		$lenentry->delete(0, 'end');
		}
	#$entry=$tmp3->Entry(-width=>"20",-background=>"lightgreen",-state=>'disabled')->pack(-side=>"right");
	}
}



###################################################################
################## Ambiguous cut-off subroutine ####################
###################################################################

sub ambiSub
{
	if($flag2==0)
	{
		$ambiframe=$frame1->LabFrame(-label=>"Ambiguous base filter",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'sw');
		$ambitable = $ambiframe->Table(
						  -columns    => 2,
						  -rows       => 2,
						  -relief     => 'groove'
						)->pack(-side=>"left");
						
		
		$ambitmp11 = $ambitable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$ambitable->put(1,1,$ambitmp11);
		$ambilabel=$ambitmp11->Label(-text=>"Enter the accepted percentage of ambiguous bases",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");
		
		$ambitmp12 = $ambitable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$ambitable->put(1,2,$ambitmp12);
		$ambientry=$ambitmp12->Entry(-width=>"10",-background=>"snow",-textvariable=>\$ambitxt)->pack(-side=>"left");
		##print "\nflag2--->",$flag2;
		$flag2=1;
	}
	if($ambicut eq 'ambicutoff')
	{
		if($flag2==1)
		{
		$ambiframe->pack(-anchor=>'sw');
		$ambientry->pack(-side=>"left");

		#print "\nflag2--->",$flag2;
		$flag2=2;
		}
	}
	elsif ($ambicut eq "null")
	{
	#print $flag2;
		if($flag2==2)
		{
		$ambiframe->packForget();
		$ambientry->packForget();
		#print "\nflag2--->",$flag2;
		$flag2=1;
		$ambientry->delete(0, 'end');
		}
	#$entry=$tmp3->Entry(-width=>"20",-background=>"lightgreen",-state=>'disabled')->pack(-side=>"right");
	}
}

#####################################################################
################## Homopolymer cut-off subroutine ###################
#####################################################################

sub homoSub
{
	if($flag3==0)
	{
		$homoframe=$frame1->LabFrame(-label=>"Homopolymer base filter",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'sw');
		$homotable = $homoframe->Table(
						  -columns    => 2,
						  -rows       => 2,
						  -relief     => 'groove'
						)->pack(-side=>"left");
						
		
		$homotmp11 = $homotable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$homotable->put(1,1,$homotmp11);
		$homolabel=$homotmp11->Label(-text=>"Enter the homopolymer cut-off",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");
		
		$homotmp12 = $homotable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$homotable->put(1,2,$homotmp12);
		$homoentry=$homotmp12->Entry(-width=>"10",-background=>"snow",-textvariable=>\$homotxt)->pack(-side=>"left");
		
		$flag3=1;
	}
	if($homocut eq 'homocutoff')
	{
		if($flag3==1)
		{
		$homoframe->pack(-anchor=>'sw');
		$homoentry->pack(-side=>"left");

		
		$flag3=2;
		}
	}
	elsif ($homocut eq "null")
	{
	
		if($flag3==2)
		{
		$homoframe->packForget();
		$homoentry->packForget();
		$flag3=1;
		$homoentry->delete(0, 'end');
		}
	
	}
}

#####################################################################
################## Left trimmer subroutine ##########################
#####################################################################

sub ltrim
{
	if($flag4==0)
	{
		$ltrimframe=$tframe1->LabFrame(-label=>"left trimmer",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'sw');
		$ltrimtable = $ltrimframe->Table(
						  -columns    => 2,
						  -rows       => 2,
						  -relief     => 'groove'
						)->pack(-side=>"left");
						
		
		$ltrimtmp11 = $ltrimtable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$ltrimtable->put(1,1,$ltrimtmp11);
		$ltrimlabel=$ltrimtmp11->Label(-text=>"Enter the left trimmer sequence",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");
		
		$ltrimtmp12 = $ltrimtable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$ltrimtable->put(1,2,$ltrimtmp12);
		$ltrimentry=$ltrimtmp12->Entry(-width=>"10",-background=>"snow",-textvariable=>\$ltrimtxt)->pack(-side=>"left");
		
		$flag4=1;
	}
	if($ltrimcut eq 'ltrim')
	{
		if($flag4==1)
		{
		$ltrimframe->pack(-anchor=>'sw');
		$ltrimentry->pack(-side=>"left");
		$flag4=2;
		}
	}
	elsif ($ltrimcut eq "null")
	{
	print "aaaa->".$flag4;
		if($flag4==2)
		{
		$ltrimframe->packForget();
		$ltrimentry->packForget();
		
		$flag4=1;
			$ltrimentry->delete(0, 'end');
		}
	
	}
}


#####################################################################
################## Left trimmer subroutine ##########################
#####################################################################

sub rtrim
{
	if($flag5==0)
	{
		$rtrimframe=$tframe1->LabFrame(-label=>"right trimmer",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'sw');
		$rtrimtable = $rtrimframe->Table(
						  -columns    => 2,
						  -rows       => 2,
						  -relief     => 'groove'
						)->pack(-side=>"left");
						
		
		$rtrimtmp11 = $rtrimtable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$rtrimtable->put(1,1,$rtrimtmp11);
		$rtrimlabel=$rtrimtmp11->Label(-text=>"Enter the right trimmer sequence",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");
		
		$rtrimtmp12 = $rtrimtable->Label(-width  => 30,
					 -height=>2,
                     -relief => 'groove');
		$rtrimtable->put(1,2,$rtrimtmp12);
		$rtrimentry=$rtrimtmp12->Entry(-width=>"10",-background=>"snow",-textvariable=>\$rtrimtxt)->pack(-side=>"left");
		
		$flag5=1;
	}
	if($rtrimcut eq 'rtrim')
	{
		if($flag5==1)
		{
		$rtrimframe->pack(-anchor=>'sw');
		$rtrimentry->pack(-side=>"left");

		
		$flag5=2;
		}
	}
	elsif ($rtrimcut eq "null")
	{
	
		if($flag5==2)
		{
		$rtrimframe->packForget();
		$rtrimentry->packForget();
		
		$flag5=1;
		$rtrimentry->delete(0, 'end');
		}
	
	}
}
####################### Flash Min Overlap ##################################


$flashframe=$pframe1->LabFrame(-label=>"Options",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'n');
$flashtable = $flashframe->Table(
				  -columns    => 4,
				  -rows       => 2,
				  -relief     => 'groove'
				)->pack(-side=>"left");
$flashtmp11 = $flashtable->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable->put(1,1,$flashtmp11);
$flashlabel=$flashtmp11->Label(-text=>"Min Overlap",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");

$flashtmp12 = $flashtable->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable->put(1,2,$flashtmp12);
$flashentry=$flashtmp12->Entry(-width=>"10",-background=>"snow",-textvariable=>\$minoverlaptxt)->pack(-side=>"left");

######################## Flash Max Overlap #################################
$flashtmp13 = $flashtable->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable->put(1,3,$flashtmp13);
$flashlabel=$flashtmp13->Label(-text=>"Max Overlap",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");

$flashtmp14 = $flashtable->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable->put(1,4,$flashtmp14);
$flashentry=$flashtmp14->Entry(-width=>"10",-background=>"snow",-textvariable=>\$maxoverlaptxt)->pack(-side=>"left");


#####################################################################################################################################################
####################### Mis match - Flash ##################################
$flashframe2=$pframe1->LabFrame(-label=>"Overlap",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'n');
$flashtable2 = $flashframe2->Table(
				  -columns    => 4,
				  -rows       => 2,
				  -relief     => 'groove'
				)->pack(-side=>"left");
$flashtmp11 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(1,1,$flashtmp11);
$flashlabel=$flashtmp11->Label(-text=>"Mismatch Ratio",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");

$flashtmp12 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(1,2,$flashtmp12);
$flashentry=$flashtmp12->Entry(-width=>"10",-background=>"snow",-textvariable=>\$mismatchtxt)->pack(-side=>"left");

######################## Phred Score - Flash #################################
$flashtmp13 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(1,3,$flashtmp13);
$flashlabel=$flashtmp13->Label(-text=>"Phred score Overlap",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");

$flashtmp14 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(1,4,$flashtmp14);
$flashentry=$flashtmp14->Entry(-width=>"10",-background=>"snow",-textvariable=>\$phredscoretxt)->pack(-side=>"left");
########################## Average Read length ################################
$flashtmp21 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(2,1,$flashtmp21);
$flashlabel=$flashtmp21->Label(-text=>"Average Read length",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");

$flashtmp22 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(2,2,$flashtmp22);
$flashentry=$flashtmp22->Entry(-width=>"10",-background=>"snow",-textvariable=>\$avgreadlentxt)->pack(-side=>"left");
########################## Average Fragment length ################################
$flashtmp23 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(2,3,$flashtmp23);
$flashlabel=$flashtmp23->Label(-text=>"Average Fragment length",-font=>[-size =>'10'])->pack(-expand => 'no',-fill => 'both',-side=>"left");

$flashtmp24 = $flashtable2->Label(-width  => 30,
			 -height=>2,
			 -relief => 'groove');
$flashtable2->put(2,4,$flashtmp24);
$flashentry=$flashtmp24->Entry(-width=>"10",-background=>"snow",-textvariable=>\$avgfraglentxt)->pack(-side=>"left");

##################################################################################################################################################
################## Upload subroutine ###########################
sub upload
{
$entry->delete(0, 'end');
$text=$mw->getOpenFile();
$entry->insert('0.0',$text);

}
sub upload1
{
	$centry->delete(0, 'end');
	$text1=$mw->getOpenFile();
	$intxt=$text1;
	$centry->insert('0.0',$intxt);
}
sub upload2
{
	$gentry->delete(0, 'end');
	$text2=$mw->getOpenFile();
	$intxt=$text2;
	$gentry->insert('0.0',$intxt);
}
sub tupload
{
	$tentry->delete(0, 'end');
	$text3=$mw->getOpenFile();
	$intxt=$text3;
	$tentry->insert('0.0',$intxt);
}
sub pupload
{
	$pentry->delete(0, 'end');
	$text4=$mw->getOpenFile();
	$intxt=$text4;
	$pentry->insert('0.0',$intxt);
}
sub p1upload
{
	$p1entry->delete(0, 'end');
	$text5=$mw->getOpenFile();
	$intxt=$text5;
	$p1entry->insert('0.0',$intxt);
}
sub do_close {
    exit;
}
######################### Submit for EasyQC tab ###############################
sub submit
{
	process();
}

######################### Flash Submit #######################
######################### Submit for EasyQC tab ###############################
sub flashsubmit
{
	flashprocess();
}

######################### trimmer submit ####################

sub tsubmit
{
	if($text3 ne '')
	{
		open(FILE,"< :raw","$text3")or die();
		@fileinput=<FILE>;
		my $value=val();
		print val();
		if($value==1)
		{
			
			 $passedTimmerValid=1;
			
			if($flag4==2 and ($ltrimtxt!~/^[ATGCatgc]+/))
			{
				$answer1 = $mw->messageBox(-title => 'Check', 
				 -message => "Left trim sequence cannot be left blank or contain Non-ATGC Sequences", 
				 -type => 'Ok');  
				$passedTimmerValid=0;
			}
			if($flag5==2 and ($rtrimtxt!~/^[ATGCatgc]+/))
			{
				$answer1 = $mw->messageBox(-title => 'Check', 
				 -message => "Right trim sequence cannot be left blank or contain Non-ATGC Sequences", 
				 -type => 'Ok');     
				$passedTimmerValid=0;
			}
			if($passedTimmerValid==1)
			{
				($filename3, $dirs3, $suffix3) = fileparse($text3);
				$f3=$filename3;
				$f3=~s/(.fastq)//;
				$dir3=$dirs3."Trimmed sequences with $f3";
				make_path($dir3);
				
				adapt();
				
			}
		}
		else
		{
		$answer => $mw->messageBox(-title => 'Check', 
     -message => 'please upload a valid file', 
     -type => 'OK');
		}
	}
	else
	{
		$answer => $mw->messageBox(-title => 'Check', 
     -message => 'please upload the file', 
     -type => 'OK');
	}
}
###################### submit for conversion tab #############
sub submit1
{
	if($text1 ne '')
	{
		open(FILE,"< :raw","$text1")or die();
		@fileinput=<FILE>;
		my $value=val();
		if($value==1)
		{
			 ($filename1, $dirs1, $suffix1) = fileparse($text1);
			open(FILE,"< :raw","$text1")or die();
			$f1=$filename1;
			$f1=~s/(.fastq)//;
			$dir2=$dirs1."Converted for $f1";
			make_path($dir2);

			while ( sysread( FILE,  $ch, 4096) )
			{
				$ab.=$ch;
			}
			@infile=split /\n/,$ab;
			close(FILE);
			convertFasta(\@infile); 
			$answer => $mw->messageBox(-title => 'Check', 
     -message => 'converted successfully', 
     -type => 'OK');# passing Fastq array
		}
	}
	else
	{
		$answer => $mw->messageBox(-title => 'Check', 
     -message => 'please upload the file', 
     -type => 'OK');
	}
}
###################### graphs tab #############
sub submit2
{
	if($text2 ne '')
	{
		open(FILE,"< :raw","$text2")or die();
		@fileinput=<FILE>;
		my $value=val();
		if($value==1)
		{
			 ($filename2, $dirs2, $suffix2) = fileparse($text2);
			open(FILE,"< :raw","$text2")or die();
			$f2=$filename2;
			$f2=~s/(.fastq)//;
			$dir3=$dirs2."graphs assosiated with $f2";
			make_path($dir3);

			while ( sysread( FILE,  $ch, 4096) )
			{
				$ab.=$ch;
			}
			@file=split /\n/,$ab;
			close(FILE);
			
			qualline();  # passing Fastq array;
			lenchart();
			$answer => $mw->messageBox(-title => 'Check', 
     -message => 'Graphs generated successfully!!', 
     -type => 'OK');
		}
	}
	else
	{
		$answer => $mw->messageBox(-title => 'Check', 
     -message => 'please upload the file', 
     -type => 'OK');
	}
}

################### Easy QC validation #############
sub process
{

chomp($text);
if($text eq '')
{

 $answer => $mw->messageBox(-title => 'Check', 
     -message => 'please upload the file', 
     -type => 'OK');
}
else
{
	 ($filename, $dirs, $suffix) = fileparse($text);
	 ($filename, $dirs, $suffix) = fileparse($text);
if($flag==2)
{
	$val1 = $slide1->get();
	$val2 = $slide2->get();
	if($val1==0)
	{
	$answer = $mw->messageBox(-title => 'Check', 
     -message => 'Do you wish to proceed with default quality cut-off value?', 
     -type => 'YesNo');                                                         # default value alert 
	 if($answer eq 'Yes')
	 {
		$slide1->set(30);
		$qcomplete1=1;
	 }
	 else
	 {
		$qcomplete1=0;
	 }
	}
	if($val2==0)
	{
	$answe = $mw->messageBox(-title => 'Check', 
     -message => 'Do you wish to proceed with default percentage cutoff?', 
     -type => 'YesNo');                                                         # default value alert 
	 
	 if($answe eq 'Yes')
	{
		$slide2->set(90);
		$qcomplete2=1;
	}
	else
	{
	$qcomplete2=0;
	}
	}
}
######## length cutoff validation
if($flag1==2 and ($lentxt!~/^\d+$/))
{
	#print ($flag1==2,",$lentxt,",$lentxt!~/^\d+$/);
	$answer1 = $mw->messageBox(-title => 'Check', 
     -message => "Length cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
     -type => 'YesNo');                                                       
	 # default value alert 
	 
	 if($answer1 eq 'Yes')
	{
		$lentxt=100;
		$lcomplete=1;
	}
	else
	{
	$lentxt='';
	$lcomplete=0;
	}
}
else
{$lcomplete=1;}	
###############ambiguous cutoff validation
if($flag2==2 and ($ambitxt!~/^\d+$/ ))
{
	$answer2 = $mw->messageBox(-title => 'Check', 
     -message => "Ambiguous bases cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
     -type => 'YesNo');                                                         # default value alert 
	 
	if($answer2 eq 'Yes')
	{
		$ambitxt=7;
		$acomplete=1;
	}
	else
	{
	$ambitxt='';
	$acomplete=0;
	}
}
else
{$acomplete=1;}
##################homopolymer validation
if($flag3==2 and ($homotxt!~/^\d+$/))
{
	$answer3 = $mw->messageBox(-title => 'Check', 
     -message => "Homopolymer cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
     -type => 'YesNo');                                                         # default value alert 
	 
	if($answer3 eq 'Yes')
	{
		$homotxt=5;
		$hcomplete=1;
	}
	else
	{
	$homotxt='';
	$hcomplete=0;
	}
}
else
{$hcomplete=1;}
if($flag!=2and$flag2!=2and$flag3!=2and$flag1!=2)
{
$answer3 = $mw->messageBox(-title => 'Check', 
     -message => "check atleast one filter", 
     -type => 'OK');
	$complete=0;
}
else
{
	$complete=1;
}
#completeness of validation and entering into pipeline
if($complete==1 and (($flag==2?($qcomplete1==1?1:0):1) and ($flag==2?($qcomplete2==1?1:0):1) and ($flag1==2?($lcomplete==1?1:0):1) and ($flag3==2?($hcomplete==1?1:0):1) and ($flag2==2?($acomplete==1?1:0):1)))
{
	
	$finalsub = $mw->messageBox(-title => 'Check', 
     -message => "Do you want to proceed with the given cut-off?", 
     -type => 'YesNo');
	 if($finalsub eq 'Yes')
	{

	 $f=$filename;
	 $f=~s/(.fastq)//;
		$time=localtime();
		$dir1=$dirs."EC-QC_Results_for_$f";
		make_path($dir1);
		open(FILE,"< :raw","$text")or die();
		@infile=();
		@infile=<FILE>;
		close(FILE);
		@fileinput=@infile;
		#@infile=split /\n/,$ab;
		$valid=val();
		#close(FILE);
		#print $dir1;
		open(LOG,">> :raw","$dir1/log.txt")or die();
		
		if($valid==1)
		{
		print LOG "\n$time : Sequence submitted for analysis\n";
		close (LOG);
		print "\n$time : Sequence submitted for analysis\n";
		pipeline();                                                         # pipeline submission
		}
		else
		{
		print LOG "\n$time : Provided a incorrect sequence for analysis\n";
		close (LOG);
		}

	}
	else
	{
	$complete=0;
	}
}
}
}

############graph buttons ####################
############graph buttons ####################
sub qualitygraph
{

$qualg = MainWindow->new(
    -title      => 'Sequence quality distribution',
    -background => 'white',
  );
  $qualg->geometry("520x520");
  $image = $qualg->Photo(-file => "$dir3/Average_quality.png");
$qualg->Button(-image => $image)->pack(-anchor=>"center");
}



sub lengthgraph
{
	$lengthg = MainWindow->new(
    -title      => 'Sequence length distribution',
    -background => 'white',
  );
  $lengthg->geometry("620x620");
 $image3 = $lengthg->Photo(-file => "$dir3/length.png");
$lengthg->Button(-image => $image3)->pack(-anchor=>"center");

}

sub atgc
{
	$lengthg = MainWindow->new(
    -title      => 'Base Composition',
    -background => 'white',
  );
  $lengthg->geometry("520x520");
 $image3 = $lengthg->Photo(-file => "$dir3/atgc.png");
$lengthg->Button(-image => $image3)->pack(-anchor=>"center");

}

sub gcpercent
{
	$lengthg = MainWindow->new(
    -title      => 'GC Percentage',
    -background => 'white',
  );
  $lengthg->geometry("520x520");
 $image3 = $lengthg->Photo(-file => "$dir3/GCPercentage.png");
$lengthg->Button(-image => $image3)->pack(-anchor=>"center");

}


################################## Flash Processss #########################################
sub flashprocess
{

chomp($text4);
if($text4 eq '')
{
 $answer => $mw->messageBox(-title => 'Check', 
     -message => 'please upload the file', 
     -type => 'OK');
}
elsif($text5 eq '')
{
$answer => $mw->messageBox(-title => 'Check', 
     -message => 'please upload the file', 
     -type => 'OK');
}
elsif($minoverlaptxt eq '' and $maxoverlaptxt eq '' and $mismatchtxt eq ''and $avgreadlentxt eq '' and $phredscoretxt eq '' and $avgfraglentxt eq '')
{
	 ($filename, $dirs, $suffix) = fileparse($text5);
	 ($filename1, $dirs1, $suffix1) = fileparse($text4);
	$answer61 = $mw->messageBox(-title => 'Check', 
		 -message => "Cut-off values cannot be left blank.\nDo you wish to Proceed with the default values?", 
		 -type => 'YesNo');                                                         # default value alert 
		if($answer61 eq 'Yes')
		{
			$minoverlaptxt=10;$maxoverlaptxt=70;$mismatchtxt=0.25;$avgreadlentxt=100;$phredscoretxt=33;$avgfraglentxt=50;
		}
		else
		{
		$minoverlaptxt='';$maxoverlaptxt='';$mismatchtxt='';$avgreadlentxt='';$phredscoretxt='';$avgfraglentxt='';
		}
}
	
else
{
	 ($filename, $dirs, $suffix) = fileparse($text5);
	 ($filename1, $dirs1, $suffix1) = fileparse($text4);
######## minumum length cutoff validation ########
	if($minoverlaptxt!~/^\d+$/)
	{
		$answer11 = $mw->messageBox(-title => 'Check', 
		 -message => "Minimum length cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
		 -type => 'YesNo');                                                         # default value alert 
		if($answer11 eq 'Yes')
		{
			$minoverlaptxt=10;
		}
		else
		{
		$minoverlaptxt='';
		}
	}
	if($maxoverlaptxt!~/^\d+$/)
	{
		$answer12 = $mw->messageBox(-title => 'Check', 
		 -message => "Maximum length cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
		 -type => 'YesNo');                                                         # default value alert 
		if($answer12 eq 'Yes')
		{
			$maxoverlaptxt=70;
		}
		else
		{
		$maxoverlaptxt='';
		}
	}
	if($mismatchtxt!~/^[\d\.]+$/)
	{
		$answer3 = $mw->messageBox(-title => 'Check', 
		 -message => "Mismatch length cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
		 -type => 'YesNo');                                                         # default value alert 
		if($answer3 eq 'Yes')
		{
			$mismatchtxt=0.25;
		}
		else
		{
		$mismatchtxt='';
		}
	}
	if($phredscoretxt!~/^\d+$/)
	{
		$answer4 = $mw->messageBox(-title => 'Check', 
		 -message => "Phred score cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
		 -type => 'YesNo');                                                         # default value alert 
		if($answer4 eq 'Yes')
		{
			$phredscoretxt=33;
		}
		else
		{
		$phredscoretxt='';
		}
	}
	if($avgreadlentxt!~/^\d+$/)
	{
		$answer5 = $mw->messageBox(-title => 'Check', 
		 -message => "Average Read length cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
		 -type => 'YesNo');                                                         # default value alert 
		if($answer5 eq 'Yes')
		{
			$avgreadlentxt=100;
		}
		else
		{
		$avgreadlentxt='';
		}
	}
	if($avgfraglentxt!~/^\d+$/)
	{
		$answer6 = $mw->messageBox(-title => 'Check', 
		 -message => "Average Fragment length cut-off value cannot be left blank.\nDo you wish to Proceed with the default value?", 
		 -type => 'YesNo');                                                         # default value alert 
		if($answer6 eq 'Yes')
		{
			$avgfraglentxt=50;
		}
		else
		{
			$avgfraglentxt='';
		}
	}
}
########################### completeness of validation and entering into pipeline ############
	if($minoverlaptxt ne '' and $maxoverlaptxt ne '' and $mismatchtxt ne ''and $avgreadlentxt ne '' and $phredscoretxt ne '' and $avgfraglentxt ne '')
	{
		#progres();
		#print "aaa";
		$finalsub = $mw->messageBox(-title => 'Check', 
		 -message => "Do you want to proceed with the given cut-off?", 
		 -type => 'YesNo');
		 if($finalsub eq 'Yes')
		{
			$f=$filename;
			$f=~s/(.fastq)//;
			$time=localtime();
			$dir1=$dirs."flash_Results_for_$f";
			make_path($dir1);
			open(FILE2,"< :raw","$text4")or die();
			@infile12=();
			@infile12=<FILE2>;
			close(FILE2);
			@fileinput=@infile12;
			@infile12=split /\n/,$ab;
			$valid1=val();
			
			open(FILE3,"< :raw","$text5")or die();
			@infile13=();
			@infile13=<FILE3>;
			close(FILE3);
			@fileinput=@infile13;
			@infile13=split /\n/,$ab;
			$valid2=val();
			
			open(LOG,">> :raw","$dir1/log.txt")or die();
			
			if($valid1==1 && $valid2==1)
			{
				$os="$^O";
				if($os eq "linux"){
					$aaa=`.\/FLASH\/flash -d \"$dir1\"/ -m $minoverlaptxt -M $maxoverlaptxt -x $mismatchtxt -p $phredscoretxt -r $avgreadlentxt -f $avgfraglentxt \"$text4\" \"$text5\"`;
					
					$answer6 = $mw->messageBox(-title => 'Check', 
			 -message => "$aaa", 
			 -type => 'Ok');  
				}
				else
				{
					$answer6 = $mw->messageBox(-title => 'Check', 
		 -message => "Sorry Your OS is not compatable to run this script", 
		 -type => 'Ok');  
				}
				print LOG "\n$time : Sequence submitted for analysis\n";
				print LOG $aaa;
				close (LOG);
				print "\n$time : Sequence submitted for analysis\n";
			}
			else
			{
				print LOG "\n$time : Provided a incorrect sequence for analysis\n";
				close (LOG);
			}

		}
		else
		{
		$complete=0;
		}
	}
}



$table->pack(-expand => 'no',-fill => 'both',-side=>"left");
$ttable->pack(-expand => 'no',-fill => 'both',-side=>"left");
MainLoop;
